using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Media;
using System.IO;

namespace IBP_PC
{
    public partial class Form1 : Form
    {
        private delegate void displayDeleg(byte [] b_buffer);
        private delegate void IdentDeleg(string stream);
        
        byte[] byte_buffer={0,0,0,0,0,0,0,0,0};
        
        int index=0;
        int old_pressure1=0;
        int old_pressure2=0;
        Graphics g;
        Bitmap bmp;

        enum Status { normal=0, no_waveform, zeroing , out_of_Rage, zeroing_failed, initializing, Zeroing_OK, no_sensor_connected, sensor_connected, simulated_output, not_calibrated, selftest_error, cable_fault, not_used};

        public Form1()
        {
            InitializeComponent();
            list_comport();
            
        }

        private void list_comport()
        {
            // Get a list of serial port names. 
            string[] ports = SerialPort.GetPortNames();

            

            // Display each port name to the console. 
            foreach (string port in ports)
            {
                //mnuCom.DropDownItems.Add(port, null, new EventHandler(port_Click));
                comToolStripMenuItem.DropDownItems.Add(port, null, new EventHandler(port_Click));
            }
        }

        private void port_Click(object sender, EventArgs e)
        {
            
            if (serialPort1.IsOpen)
                serialPort1.Close();
            serialPort1.ReadBufferSize = 64;
            serialPort1.ReceivedBytesThreshold = 5;
            string Port = sender.ToString();
            serialPort1.PortName = Port;
            
            try
            {
                serialPort1.Open();
            }
            catch
            {
                MessageBox.Show("Serial port " + serialPort1.PortName +
                       " cannot be opened!", "RS232 tester",
                       MessageBoxButtons.OK, MessageBoxIcon.Warning);
               
            };
            
            serialPort1.WriteLine("I");

            toolStripStatusLabel_port.Text = Port;
            int i = 0;
            while ((label_Identify.Text == ""))
            {
                if (i++ < 10)
                {
                    
                    serialPort1.WriteLine("I");
                    System.Threading.Thread.Sleep(50);
                    //buffer = serialPort1.ReadTo("\0");
                    //this.BeginInvoke(new IdentDeleg(ident), new object[] { buffer });
                }
                else 
                {
                    break;
                }
            }
            serialPort1.WriteLine("Z1");
            serialPort1.WriteLine("O"); 
            serialPort1.WriteLine("S1");

            //button_Identify.Enabled = true;
            button_Speed.Enabled = true;
            button_ZeroAll.Enabled = true;
            button_ZeroCh1.Enabled = true;
            button_ZeroCh2.Enabled = true;
            radioButton1.Enabled = true;
            radioButton2.Enabled = true;
            radioButton3.Enabled = true;
            radioButton4.Enabled = true;
            button1.Enabled = true;
            
            
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            string buffer="";
            byte buf=0;
            //byte[] b_buffer ={ 0,0,0,0,0,0,0,0,0};
            while (serialPort1.BytesToRead > 10)
            {
                buf = Convert.ToByte(serialPort1.ReadByte());
                byte[] b_buffer ={ 0, 0, 0, 0, 0, 0, 0, 0, 0 };
                if ((buf & 0x80) == 0x80)
                {
                    if ((buf & 0xE0) == 0xE0)
                    {
                        //if (serialPort1.BytesToRead >= 8)
                        buffer = serialPort1.ReadTo("\0");
                        this.BeginInvoke(new IdentDeleg(ident), new object[] { buffer });
                        
                                             
                    }

                    else
                    {
                        byte_buffer[0] = buf;
                        if ((byte_buffer[0] & 0xC0) == 0xC0)
                        {
                            
                            serialPort1.Read(byte_buffer, 1, 2);
                            
                        }
                        else if ((byte_buffer[0] & 0x80) == 0x80)
                        {
                           
                            serialPort1.Read(byte_buffer, 1, 8);
                            
                        }

                        byte_buffer.CopyTo(b_buffer, 0);
                        //this.Invoke(new EventHandler(Display));
                        this.BeginInvoke(new displayDeleg(Display), new object[] { b_buffer });

                    }
                }
            }
        }
       
        private void Display(byte [] b_buffer)
        {
            int temp = 0;
            byte[]mybuffer= { 0,0,0,0,0,0,0,0,0};
            b_buffer.CopyTo(mybuffer, 0);
            //CheckForIllegalCrossThreadCalls = false;

            if ((mybuffer[0] & 0xD0) == 0xD0)   // Status package
            {
                //int temp_buffer = (b_buffer[1]&0x0F);
                label_StatusCh1.Text = ((Status)(mybuffer[1] & 0x0F)).ToString("f");
                label_StatusCh2.Text = ((Status)(mybuffer[2] & 0x0F)).ToString("f");
            }


            else if ((mybuffer[0] & 0xC0) == 0xC0)    // Waveform package
            {
                int y1, y2;
                y1 = (((mybuffer[0] & 0x0C) << 5) + mybuffer[1] - 100);
                y2 = (((mybuffer[0] & 0x03) << 7) + mybuffer[2] - 100);
                draw(y1, y2);
            }

            else if ((mybuffer[0] & 0x80) == 0x80)   // Information package
            {
                // CHannel 1
                temp = ((((int)mybuffer[0] & 0x30) << 3) + (mybuffer[1]));
                label_SysPressureCh1.Text = Convert.ToString((temp - 100));
                temp = ((((int)mybuffer[0] & 0x0C) << 5) + (mybuffer[2]));
                label_MapPressureCh1.Text = Convert.ToString((temp - 100));
                temp = ((((int)mybuffer[0] & 0x03) << 7) + (mybuffer[3]));
                label_DiaPressureCh1.Text = Convert.ToString((temp - 100));
                // CHannel 2
                temp = ((((int)mybuffer[4] & 0x30) << 3) + (mybuffer[5]));
                label_SysPressureCh2.Text = Convert.ToString((temp - 100));
                temp = ((((int)mybuffer[4] & 0x0C) << 5) + (mybuffer[6]));
                label_MapPressureCh2.Text = Convert.ToString((temp - 100));
                temp = ((((int)mybuffer[4] & 0x03) << 7) + (mybuffer[7]));
                label_DiaPressureCh2.Text = Convert.ToString((temp - 100));
                // Pulse
                temp = ((((int)mybuffer[4] & 0x40) << 1) + (mybuffer[8]));
                label_Pulse.Text = Convert.ToString(temp);
            }
            else
            {
                Console.WriteLine("invalid package");
            }
        
        }

        private void ident(string stream)
        {
            label_Identify.Text = stream;

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            bmp = new Bitmap(pictureBox2.Width, pictureBox2.Height);
             g = Graphics.FromImage(bmp);
             double bmpfactor = pictureBox2.Height / 340.0;
             
            for (index = 0; index < pictureBox2.Width; index++)
             {
                 if (index % 4 == 0)
                 {
                     g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(20 * bmpfactor), 1, 1);
                     g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(120 * bmpfactor), 1, 1);
                     g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(220 * bmpfactor), 1, 1);
                     g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(320 * bmpfactor), 1, 1);
                 }
             }
             pictureBox2.Image = bmp;
        }
        
       // private void button_Identify_Click(object sender, EventArgs e)
       // {
       //     serialPort1.WriteLine("I");
       // }

        private void button_ZeroAll_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine("Z3");
        }

        private void button_ZeroCh1_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine("Z1");
        }

        private void button_ZeroCh2_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine("Z2");
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            serialPort1.WriteLine("O");
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            serialPort1.WriteLine("M");
        }

        private void button_Speed_Click(object sender, EventArgs e)
        {
            
            if (label_Speed.Text == "50")
            {
                label_Speed.Text = "100";
                serialPort1.WriteLine("S1");
            }
            else if (label_Speed.Text == "100")
            {
                label_Speed.Text = "150";
                serialPort1.WriteLine("S2");
            }
            else if (label_Speed.Text == "150")
            {
                label_Speed.Text = "50";
                serialPort1.WriteLine("S0");
            }
                
           

        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            serialPort1.WriteLine("5");
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            serialPort1.WriteLine("6");
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            pictureBox2.Image = bmp;
            
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabeltime.Text = DateTime.Now.ToLongTimeString();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void infoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 about = new AboutBox1();
            about.Show();
        }

        private void draw(int Pressure1, int Pressure2)
        {
            double bmpfactor = pictureBox2.Height / 340.0;
            
            if (index < pictureBox2.Width) 
            {
                index = index+ 2;
            }
            else
            {
                index = 0;
            }

            Pressure1 = (int)(bmp.Height - ((Pressure1+20)*bmpfactor) );
            Pressure2 = (int)(bmp.Height - ((Pressure2+20)*bmpfactor)+1 );
            

            g.DrawLine (new Pen(Color.White,2), index, 0, index, bmp.Height);
            g.DrawLine (new Pen(Color.White,2),index + 1, 0, index + 1, bmp.Height);


            if (index % 4 == 0) 
            {
                g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(20 * bmpfactor), 1, 1);
                g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(120 * bmpfactor), 1, 1);
                g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(220 * bmpfactor), 1, 1);
                g.DrawRectangle(new Pen(Color.Gray, 1), index, bmp.Height - (int)(320 * bmpfactor), 1, 1);
            }

            
            if (index >= 1) 
            {
                g.DrawLine (new Pen(Color.Red, 2),index - 2, old_pressure1, index, Pressure1);
                g.DrawLine (new Pen(Color.Blue, 2),index - 2, old_pressure2, index, Pressure2);
            }


            old_pressure1 = Pressure1;
            old_pressure2 = Pressure2;

           
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Environment.Exit(0);
        }
        
        StreamWriter Outfile;
        bool Outfilectr = false;

        private void savefileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Title = "Select a file";
            dialog.DefaultExt = "txt";
            dialog.Filter =
            "Text files (*.txt)|*.txt|All files (*.*)|*.*";

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                Outfile = new StreamWriter(dialog.FileName);
                Outfilectr = true;

                toolStripStatusLabel1.Text =  dialog.FileName;
            }
        }

        private void Identify_Click(object sender, EventArgs e)
        {
            serialPort1.WriteLine("I");
        }

        
       
    } 
}